(function() {
    var A, base1, bind = function(a, b) {
            return function() {
                return a.apply(b, arguments)
            }
        },
        hasProp = {}.hasOwnProperty,
        indexOf = [].indexOf || function(a) {
            for (var i = 0, l = this.length; i < l; i++) {
                if (i in this && this[i] === a) return i
            }
            return -1
        };
    if ((A = Function.prototype).bind == null) {
        A.bind = function(a) {
            var b, fBound, fNOP, fToBind;
            if (typeof this !== 'function') {
                throw new TypeError('Function.prototype.bind - what is trying to be bound is not callable');
            }
            b = Array.prototype.slice.call(arguments, 1);
            fToBind = this;
            fNOP = function() {};
            fBound = function() {
                return fToBind.apply((this instanceof fNOP ? this : a), b.concat(Array.prototype.slice.call(arguments)))
            };
            if (this.prototype) {
                fNOP.prototype = this.prototype
            }
            fBound.prototype = new fNOP();
            return fBound
        }
    }
    if ((base1 = Element.prototype).remove == null) {
        base1.remove = function() {
            if (this.parentNode) {
                return this.parentNode.removeChild(this)
            }
        }
    }
    window.PriceChart = (function() {
        PriceChart.opts = null;
        PriceChart.current = null;
        PriceChart.data = null;
        PriceChart.secondary_data = null;
        PriceChart.transition = null;
        PriceChart.annotations = null;
        PriceChart.overlays = null;
        PriceChart.events = null;
        PriceChart.transitionCount = 0;
        PriceChart.mode = null;

        function PriceChart(c) {
            var d, base3, base4, base5, base6, base7, base8, label, ref, ref1, ref10, ref11, ref12, ref13, ref14, ref15, ref16, ref17, ref18, ref19, ref2, ref20, ref21, ref22, ref23, ref24, ref25, ref26, ref27, ref28, ref29, ref3, ref30, ref31, ref32, ref33, ref34, ref35, ref36, ref4, ref5, ref6, ref7, ref8, ref9, wrapper;
            if (c == null) {
                c = {}
            }
            this.decrementTransitions = bind(this.decrementTransitions, this);
            this.incrementTransitions = bind(this.incrementTransitions, this);
            this.drawEndValue = bind(this.drawEndValue, this);
            this.createEmptyWrapper = bind(this.createEmptyWrapper, this);
            this.hideTooltip = bind(this.hideTooltip, this);
            this.moveTooltip = bind(this.moveTooltip, this);
            this.showTooltip = bind(this.showTooltip, this);
            this.initialOpts = c;
            this.transitionCount = 0;
            this.events = d3.dispatch("error", "destroy", "resize", "renderComplete");
            if (this.opts == null) {
                this.opts = {}
            }
            if (this.current == null) {
                this.current = {}
            }
            this.dataset = new PriceChart.Dataset({
                instance: this,
                sourceUrl: c.data_source
            });
            this.resetScales();
            this.opts.compatibility_mode = !!c.compatibility_mode;
            this.opts.wrappers = (function() {
                if ((ref = c.wrappers) != null) {
                    return ref
                } else {
                    throw "Undefined wrappers";
                }
            })();
            ref1 = this.opts.wrappers;
            for (label in ref1) {
                wrapper = ref1[label];
                if (wrapper.overlays != null) {
                    wrapper.overlays = wrapper.overlays.map((function(b) {
                        return function(a) {
                            return new PriceChart.OverlayDefinition(b, a)
                        }
                    })(this))
                }
            }
            this.opts.height = (ref2 = c.height) != null ? ref2 : 375;
            this.opts.secondary_height = (ref3 = c.secondary_height) != null ? ref3 : 0.25;
            this.opts.width = (ref4 = c.width) != null ? ref4 : 500;
            this.opts.margins = (ref5 = c.margins) != null ? ref5 : {
                top: 20,
                right: 50,
                bottom: 80,
                left: 50
            };
            this.opts.canvas = (function() {
                if ((ref6 = c.canvas) != null) {
                    return ref6
                } else {
                    throw "Undefined canvas selector";
                }
            })();
            this.opts.colors = (ref7 = c.colors) != null ? ref7 : ["#19a44a", "#5d2a78", "#a173b2", "#1c61ae", "#3a9dc8", "#af792b", "#cfac2e"];
            this.opts.bar_color = (ref8 = c.bar_color) != null ? ref8 : "#1168a5";
            this.opts.bar_spacing = (ref9 = c.bar_spacing) != null ? ref9 : 0.0;
            this.opts.background_color = (ref10 = this.parseColorOption(c.background_color)) != null ? ref10 : "transparent";
            this.opts.secondary_background_color = (ref11 = this.parseColorOption(c.secondary_background_color)) != null ? ref11 : new PriceChart.GradientGenerator("#ddebf5", "#ffffff");
            this.opts.watermark = c.watermark;
            if (this.opts.watermark) {
                if ((ref12 = this.opts.watermark.source) != null) {
                    ref12
                } else {
                    throw "Background image specified, but no 'source' attribute given";
                };
                if ((d = this.opts.watermark).height == null) {
                    d.height = "100%"
                }
                if ((base3 = this.opts.watermark).width == null) {
                    base3.width = "100%"
                }
                if ((base4 = this.opts.watermark).x == null) {
                    base4.x = "100%"
                }
                if ((base5 = this.opts.watermark).y == null) {
                    base5.y = "100%"
                }
                if (!(this.opts.watermark.x.indexOf("%") >= 0 && this.opts.watermark.y.indexOf("%") >= 0)) {
                    throw "Background image position must be specified as a percent";
                }
            }
            this.opts.png_convert_endpoint = c.png_convert_endpoint;
            this.opts.data_formatter = c.data_formatter;
            this.opts.transition_duration = (ref13 = c.transition_duration) != null ? ref13 : 500;
            this.opts.error_image = c.error_image;
            this.opts.show_end_values = (ref14 = c.show_end_values) != null ? ref14 : false;
            this.opts.end_value_style = PriceChart.Config.parse(c.end_value_style, PriceChart.Config.END_VALUE_STYLE__VALUES);
            this.opts.end_value_function = {};
            this.opts.end_value_function.left = (ref15 = (ref16 = c.end_value_function) != null ? ref16.left : void 0) != null ? ref15 : PriceChart.Config.END_VALUE_FUNCTION__LEFT_SIDE;
            this.opts.end_value_function.right = (ref17 = (ref18 = c.end_value_function) != null ? ref18.right : void 0) != null ? ref17 : PriceChart.Config.END_VALUE_FUNCTION__RIGHT_SIDE;
            this.opts.ymin = (ref19 = c.ymin) != null ? ref19 : null;
            this.opts.ymax = (ref20 = c.ymax) != null ? ref20 : null;
            this.opts.ymin_overlay = (ref21 = c.ymin_overlay) != null ? ref21 : null;
            this.opts.ymax_overlay = (ref22 = c.ymax_overlay) != null ? ref22 : null;
            this.opts.show_legend = (ref23 = c.show_legend) != null ? ref23 : true;
            this.opts.show_grid = (ref24 = c.show_grid) != null ? ref24 : false;
            this.opts.maximum_date_range = (ref25 = c.maximum_date_range) != null ? ref25 : 2e308;
            this.opts.line_properties = (ref26 = c.line_properties) != null ? ref26 : {};
            if ((base6 = this.opts.line_properties)["default"] == null) {
                base6["default"] = {}
            }
            if ((base7 = this.opts.line_properties["default"])['stroke-width'] == null) {
                base7['stroke-width'] = '1px'
            }
            if ((base8 = this.opts.line_properties["default"])['stroke-dasharray'] == null) {
                base8['stroke-dasharray'] = ""
            }
            this.opts.draw_mode_colors = (ref27 = c.draw_mode_colors) != null ? ref27 : null;
            this.opts.draw_mode_default_width = (ref28 = c.draw_mode_default_width) != null ? ref28 : null;
            this.opts.price_info_on_hover = (ref29 = c.price_info_on_hover) != null ? ref29 : true;
            this.current.date_range = [null, null];
            this.current.colors = this.opts.colors.slice(0);
            this.current.lines = {};
            this.transition = false;
            if (c.initial_values != null) {
                this.current.symbol = c.initial_values.symbol;
                this.current.wrapper = c.initial_values.wrapper;
                this.current.period = c.initial_values.period;
                this.current.date_range[0] = (ref30 = c.initial_values.from_date) != null ? ref30 : null;
                this.current.date_range[1] = (ref31 = c.initial_values.to_date) != null ? ref31 : null;
                this.current.chart_type = (ref32 = c.initial_values.chart_type) != null ? ref32 : 'line';
                this.current.secondary_chart_type = (ref33 = c.initial_values.secondary_chart_type) != null ? ref33 : null;
                this.current.secondary_wrapper = (ref34 = c.initial_values.secondary_wrapper) != null ? ref34 : null;
                this.current.annotations = (ref35 = c.initial_values.annotations) != null ? ref35 : true;
                this.current.overlays = (ref36 = c.initial_values.overlays) != null ? ref36 : true
            }
            this.tooltip = d3.select(this.opts.canvas).append('div').attr('class', 'tooltip');
            this.events.on("resize.chartObject", this.redraw.bind(this));
            if (c.mode != null) {
                this.events.on("renderComplete.chartObject", (function(a) {
                    return function() {
                        if (c.mode === "draw") {
                            a.enterDrawMode()
                        } else if (c.mode === "zoom") {
                            a.enterZoomMode()
                        }
                        return a.events.on("renderComplete.chartObject", null)
                    }
                })(this))
            }
        }
        PriceChart.prototype.set = function(a, b, c) {
            if (c == null) {
                c = true
            }
            if (a === 'from_date') {
                this.current.date_range[0] = this.parseDate(b)
            } else if (a === 'to_date') {
                this.current.date_range[1] = this.parseDate(b)
            } else {
                this.current[a] = b
            }
            if (c) {
                return this.update()
            }
        };
        PriceChart.prototype.redraw = function(a, b) {
            var k, oldTransition;
            if (a == null) {
                a = {}
            }
            if (b == null) {
                b = false
            }
            for (k in a) {
                if (!hasProp.call(a, k)) continue;
                if (k === 'end_value_style') {
                    this.opts[k] = PriceChart.Config.parse(a[k])
                } else {
                    this.opts[k] = a[k]
                }
            }
            this.destroy();
            if (b === false) {
                oldTransition = this.opts.transition_duration;
                this.opts.transition_duration = 0
            }
            this.transition = false;
            this.draw();
            if (b === false) {
                this.opts.transition_duration = oldTransition
            }
            return this.transition = true
        };
        PriceChart.prototype.setLineAttribute = function(a, b, c) {
            if (this.current.lines[a] != null) {
                return !!d3.select(this.current.lines[a]).transition().duration(this.opts.transition_duration).style(b, c)
            } else {
                return false
            }
        };
        PriceChart.prototype.enableOverlay = function(a, b) {
            var c;
            if (b == null) {
                b = this.current.wrapper
            }
            if (a.key == null) {
                throw "Missing key value for overlay";
            }
            if ((c = this.opts.wrappers[b]).overlays == null) {
                c.overlays = []
            }
            return this.opts.wrappers[b].overlays.push(new PriceChart.OverlayDefinition(this, a))
        };
        PriceChart.prototype.disableOverlay = function(a, b) {
            var j, len, newOverlays, overlay, ref;
            if (b == null) {
                b = this.current.wrapper
            }
            if (typeof a === 'string' || a instanceof String) {
                a = {
                    key: a
                }
            }
            newOverlays = [];
            if (a != null) {
                ref = this.opts.wrappers[b].overlays || [];
                for (j = 0, len = ref.length; j < len; j++) {
                    overlay = ref[j];
                    if (!overlay.matchesOpts(a)) {
                        newOverlays.push(overlay)
                    }
                }
                if (a.key && this.current.wrapper === b) {
                    delete this.current.lines[a.key]
                }
            }
            return this.opts.wrappers[b].overlays = newOverlays
        };
        PriceChart.prototype.getValue = function(a, b) {
            var d, data, j, l, len, len1, ref, value;
            data = null;
            ref = this.overlays;
            for (j = 0, len = ref.length; j < len; j++) {
                d = ref[j];
                if (d[0] === b) {
                    data = d[1]
                }
            }
            if (!data) {
                return null
            }
            value = null;
            for (l = 0, len1 = data.length; l < len1; l++) {
                d = data[l];
                if (!value || (d.date > value && d.date <= a)) {
                    value = d.value
                }
            }
            return value
        };
        PriceChart.prototype.getJSON = function(a, b) {
            if (a == null) {
                a = this.current.symbol
            }
            if (b == null) {
                b = this.opts.wrappers[this.current.wrapper].api_key
            }
            return this.dataset.getJSON(b, a)
        };
        PriceChart.prototype.enterDisplayMode = function() {
            var a;
            if ((a = this.mode) != null) {
                a.destroy()
            }
            return this.mode = null
        };
        PriceChart.prototype.enterDrawMode = function() {
            var a;
            if ((a = this.mode) != null) {
                a.destroy()
            }
            return this.mode = new PriceChart.DrawMode(this)
        };
        PriceChart.prototype.enterZoomMode = function() {
            var a;
            if ((a = this.mode) != null) {
                a.destroy()
            }
            return this.mode = new PriceChart.ZoomMode(this)
        };
        PriceChart.prototype.reset = function() {
            this.destroy();
            this.constructor(this.initialOpts);
            return this.update()
        };
        PriceChart.prototype.parseData = function(c, d, e, f) {
            var g, data, k, ref, series, v;
            if (e == null) {
                e = this.current.symbol
            }
            if (f == null) {
                f = false
            }
            data = [];
            if (c[e]) {
                series = (ref = c[e][d]) != null ? ref : c[e][this.current.period + "_" + d]
            }
            if (series != null) {
                for (k in series) {
                    v = series[k];
                    data.push({
                        date: this.parseDate(k),
                        value: parseFloat(v)
                    })
                }
            } else if (f) {
                if ((g = this.opts.wrappers)[d] == null) {
                    g[d] = this.createEmptyWrapper(d)
                }
                this.dataset.fetch(this.opts.wrappers[d].api_key, e, (function(b) {
                    return function(a) {
                        return b.update()
                    }
                })(this));
                return false
            } else {
                this.error = "Parse error: Could not find key " + d + " in data"
            }
            return data
        };
        PriceChart.prototype.colorize = function(a, b) {
            var c, ref, ref1;
            if (a && (c = (ref = this.getOverlayOpts(a, b)) != null ? ref['color'] : void 0)) {
                return c
            } else {
                return (ref1 = this.current.colors.shift()) != null ? ref1 : '#000000'
            }
        };
        PriceChart.prototype.resetColors = function() {
            return this.current.colors = this.opts.colors.slice(0)
        };
        PriceChart.prototype.resetScales = function() {
            var j, len, ref, ref1, ref2, ref3, ref4, results, s;
            if (!this.scales) {
                return this.scales = {
                    top: new PriceChart.Scale({
                        axis: PriceChart.Scale.X_AXIS,
                        orientation: "top",
                        chart: this
                    }),
                    bottom: new PriceChart.Scale({
                        axis: PriceChart.Scale.X_AXIS,
                        chart: this
                    }),
                    left: new PriceChart.Scale({
                        axis: PriceChart.Scale.Y_AXIS,
                        orientation: "left",
                        chart: this
                    }),
                    right: new PriceChart.Scale({
                        axis: PriceChart.Scale.Y_AXIS,
                        chart: this
                    }),
                    additional: []
                }
            } else {
                if ((ref = this.scales.top) != null) {
                    ref.remove()
                }
                if ((ref1 = this.scales.bottom) != null) {
                    ref1.remove()
                }
                if ((ref2 = this.scales.left) != null) {
                    ref2.remove()
                }
                if ((ref3 = this.scales.right) != null) {
                    ref3.remove()
                }
                ref4 = this.scales.additional;
                results = [];
                for (j = 0, len = ref4.length; j < len; j++) {
                    s = ref4[j];
                    results.push(s.remove())
                }
                return results
            }
        };
        PriceChart.prototype.update = function() {
            this.error = null;
            this.current.lines = {};
            if (!(this.current.wrapper in this.opts.wrappers)) {
                this.opts.wrappers[this.current.wrapper] = this.createEmptyWrapper(this.current.wrapper)
            }
            return this.dataset.fetch(this.opts.wrappers[this.current.wrapper].api_key, this.current.symbol, this.run.bind(this))
        };
        PriceChart.prototype.run = function(e) {
            var f, j, key, len, overlay, ref, ref1, ref2, ref3, ref4, secondary_key, source_url, v;
            key = this.opts.wrappers[this.current.wrapper].key;
            if (this.opts.wrappers[this.current.wrapper].periodicity) {
                key = (this.current.period + "_") + key
            }
            this.data = this.parseData(e, key);
            if (this.opts.wrappers[this.current.wrapper].annotation_key != null) {
                this.annotations = this.parseData(e, this.opts.wrappers[this.current.wrapper].annotation_key);
                this.annotation_formatter = this.opts.wrappers[this.current.wrapper].annotation_formatter
            }
            if (this.opts.wrappers[this.current.wrapper].overlays != null) {
                this.overlays = [];
                ref = this.opts.wrappers[this.current.wrapper].overlays;
                for (j = 0, len = ref.length; j < len; j++) {
                    overlay = ref[j];
                    if (overlay.type === PriceChart.ComputedMovingAverageDataObject) {
                        v = this.dataset.findOrCreateComputedMovingAverage(overlay, (ref1 = overlay.symbol) != null ? ref1 : this.current.symbol);
                        if (v === false) {
                            return
                        }
                        if (v.length) {
                            this.overlays.push([overlay.internalKey(), v, (ref2 = overlay.symbol) != null ? ref2 : this.current.symbol])
                        }
                    } else {
                        f = this.dataset.findAPIDataObject(overlay, (ref3 = overlay.symbol) != null ? ref3 : this.current.symbol);
                        v = this.parseData(f != null ? f : e, overlay.key, overlay.symbol, true);
                        if (v === false) {
                            return
                        }
                        if (v.length) {
                            this.overlays.push([overlay.internalKey(), v, (ref4 = overlay.symbol) != null ? ref4 : this.current.symbol])
                        }
                    }
                }
            }
            if (this.current.secondary_wrapper) {
                secondary_key = this.opts.wrappers[this.current.secondary_wrapper].key;
                if (this.opts.wrappers[this.current.secondary_wrapper].periodicity) {
                    secondary_key = (this.current.period + "_") + secondary_key
                }
                if (secondary_key in e) {
                    this.secondary_data = this.parseData(e, secondary_key);
                    this.draw();
                    return this.transition = true
                } else {
                    secondary_key = this.opts.wrappers[this.current.secondary_wrapper].key;
                    source_url = this.dataset.sourceUrl.replace("{WRAPPER}", this.opts.wrappers[this.current.secondary_wrapper].api_key).replace("{SYMBOL}", this.current.symbol);
                    return d3.json(source_url, (function(d) {
                        return function(a, b) {
                            var c;
                            c = {};
                            c[d.current.symbol] = b;
                            d.secondary_data = d.parseData(c, secondary_key);
                            d.draw();
                            return d.transition = true
                        }
                    })(this))
                }
            } else {
                this.draw();
                return this.transition = true
            }
        };
        PriceChart.prototype.initMouseEvents = function(b, x, y) {
            var c;
            if (this.opts.price_info_on_hover) {
                c = this;
                b.on('mouseover', null).on('mousemove', null).on('mouseout', null);
                b.on('mouseover', function() {
                    var a;
                    a = d3.select(c.opts.canvas + " div.chartinfo");
                    if (a.empty()) {
                        a = d3.select(c.opts.canvas).append("div").attr("class", "chartinfo")
                    }
                    return a.style("display", "block").style("top", c.opts.margins.top + "px").style("left", c.opts.margins.left + "px")
                });
                b.on('mousemove', function() {
                    var a, dval, pos, xpos, ypos;
                    pos = d3.mouse(this);
                    xpos = pos[0];
                    ypos = pos[1];
                    a = new Date(Math.round(x.invert(xpos)));
                    dval = c.closestDateValue(a, c.data);
                    return d3.select(c.opts.canvas + " div.chartinfo").html(c.dataFormatter.bind(c)(a, dval))
                });
                return b.on('mouseout', function() {
                    return d3.select(c.opts.canvas + " div.chartinfo").style("display", "none")
                })
            } else {
                return d3.select(this.opts.canvas + " div.chartinfo").style("display", "none")
            }
        };
        PriceChart.prototype.createOrGetPrimaryChart = function() {
            var a, defs, g, svg, x, y;
            if (document.querySelectorAll(".primary-chart").length) {
                svg = d3.select(this.opts.canvas + " .primary-chart").attr("height", this.opts.height)
            } else {
                a = d3.select(this.opts.canvas).append("svg").attr("width", this.opts.width + this.opts.margins.left + this.opts.margins.right).attr("height", this.opts.height + this.opts.margins.top + this.opts.margins.bottom).attr("version", "1.1").attr("xmlns", "http://www.w3.org/2000/svg").attr("xmlns:xlink", "http://www.w3.org/1999/xlink");
                this.node = a[0][0];
                if (!a.selectAll(".axis")[0][0]) {
                    this.transition = false
                }
                svg = a.append("g").attr("class", "wrapper").attr("transform", "translate(" + this.opts.margins.left + ", " + this.opts.margins.top + ")").append("svg").attr("class", "primary-chart").attr("height", this.opts.height);
                defs = d3.select(this.opts.canvas + " svg").append("defs");
                if (!this.opts.compatibility_mode) {
                    if (this.opts.background_color instanceof PriceChart.GradientGenerator) {
                        this.opts.background_color.generate(defs)
                    }
                    if (this.opts.secondary_background_color instanceof PriceChart.GradientGenerator) {
                        this.opts.secondary_background_color.generate(defs)
                    }
                }
                g = d3.select(this.opts.canvas + " svg g.wrapper");
                g.insert("rect", ":first-child").attr("class", "border").attr("height", this.opts.height).attr("width", this.opts.width).attr("stroke", "black").attr("stroke-width", "1px").attr("fill", this.opts.background_color instanceof PriceChart.GradientGenerator ? "url(#" + this.opts.background_color.id + ")" : this.opts.background_color).attr("shape-rendering", "crispEdges");
                if (this.opts.watermark) {
                    x = parseInt(this.opts.watermark.x, 10) / 100.0 * (this.opts.width - parseInt(this.opts.watermark.width, 10));
                    y = parseInt(this.opts.watermark.y, 10) / 100.0 * (this.opts.height - parseInt(this.opts.watermark.height, 10));
                    a.insert("g").attr("transform", "translate(" + this.opts.margins.left + ", " + this.opts.margins.top + ")").append("svg").attr("height", this.opts.height).attr("width", this.opts.width).insert("image").attr("xlink:href", this.opts.watermark.source).attr("x", x).attr("y", y).attr("width", this.opts.watermark.width).attr("height", this.opts.watermark.height)
                }
            }
            return svg
        };
        PriceChart.prototype.createOrGetSecondaryChart = function() {
            var a;
            if (document.querySelectorAll(".secondary-chart").length) {
                a = d3.select(this.opts.canvas + " .secondary-chart")
            } else {
                a = d3.select(this.opts.canvas + " svg g.wrapper").append("g").attr("class", "secondary-chart").attr("height", this.opts.secondary_height * this.opts.height).attr("width", this.opts.width).attr("transform", "translate(0," + (this.opts.height - (this.opts.secondary_height * this.opts.height)) + ")")
            }
            return a
        };
        PriceChart.prototype.draw = function() {
            var c, d, data, dataset, date_range, dates, defunctLayer, defunctScale, idx, inverted_axis, j, key, l, label, labelledOverlays, layer, layerMap, layers, len, len1, len2, len3, len4, len5, m, n, overlay, overlayLabelIsPresent, p, primary_chart, primary_height, q, ref, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, scale, scaleCountHasChanged, secondary_chart, step, str, svg, t, text, tickValues, u, value_buffer, value_range, values, x, y, yMax, yMin, z;
            if (this.error) {
                this.abort();
                return
            }
            this.resetColors();
            this.resetErrors();
            this.resetScales();
            dates = [];
            values = [];
            primary_chart = this.createOrGetPrimaryChart();
            secondary_chart = this.createOrGetSecondaryChart();
            svg = d3.select(this.opts.canvas + " svg g.wrapper");
            ref = this.data;
            for (j = 0, len = ref.length; j < len; j++) {
                d = ref[j];
                if (!this._isValid(d)) {
                    continue
                }
                dates.push(d.date);
                values.push(d.value)
            }
            dates.sort(function(a, b) {
                return b - a
            });
            date_range = [this.current.date_range[0] || dates[dates.length - 1], this.current.date_range[1] || (new Date())];
            values.sort(function(a, b) {
                return a - b
            });
            yMin = (ref1 = this.opts.ymin) != null ? ref1 : values[0];
            yMax = (ref2 = this.opts.ymax) != null ? ref2 : values[values.length - 1];
            if (this.current.overlays) {
                ref5 = (ref3 = (ref4 = this.opts.wrappers[this.current.wrapper]) != null ? ref4.overlays : void 0) != null ? ref3 : [];
                for (l = 0, len1 = ref5.length; l < len1; l++) {
                    overlay = ref5[l];
                    if (overlay.layer === 0) {
                        key = (overlay.internalKey()) + "-" + (overlay.symbol || this.current.symbol);
                        dataset = (ref6 = (this.overlays.filter((function(a) {
                            return function(o) {
                                return (o[0] + "-" + o[2]) === key
                            }
                        })(this)))[0]) != null ? ref6[1] : void 0;
                        if (dataset) {
                            for (m = 0, len2 = dataset.length; m < len2; m++) {
                                d = dataset[m];
                                if ((d.value != null) && !isNaN(d.value) && (date_range[0].getTime() <= (ref7 = d.date.getTime()) && ref7 <= date_range[1].getTime())) {
                                    if (d.value > yMax) {
                                        yMax = d.value
                                    }
                                    if (d.value < yMin) {
                                        yMin = d.value
                                    }
                                }
                            }
                        }
                    }
                }
            }
            value_buffer = (yMax - yMin) * 0.1;
            value_range = [yMin - value_buffer, yMax + value_buffer];
            primary_height = this.current.secondary_chart_type ? this.opts.height - (this.opts.secondary_height * this.opts.height) : this.opts.height;
            tickValues = [];
            for (n = p = 0; p <= 5; n = ++p) {
                step = (yMax - yMin) / 5;
                tickValues.push(yMin + (n * step))
            }
            inverted_axis = !!this.opts.wrappers[this.current.wrapper].inverted_axis;
            this.scales.top.update({
                domain: date_range,
                range: [0, this.opts.width],
                type: PriceChart.Scale.TIME_SCALE,
                tickCount: 0,
                orientation: 'top'
            });
            this.scales.bottom.update({
                domain: date_range,
                range: [0, this.opts.width],
                type: PriceChart.Scale.TIME_SCALE,
                ticks: Math.floor(this.opts.width) / 100,
                innerTickSize: this.opts.show_grid ? -this.opts.height : void 0
            });
            this.scales.right.update({
                domain: value_range,
                range: inverted_axis ? [0, primary_height] : [primary_height, 0],
                type: PriceChart.Scale.LINEAR_SCALE,
                tickValues: tickValues,
                innerTickSize: this.opts.show_grid ? -this.opts.width - 6 : void 0
            });
            this.scales.left.update({
                domain: value_range,
                range: inverted_axis ? [0, primary_height] : [primary_height, 0],
                type: PriceChart.Scale.LINEAR_SCALE,
                tickCount: 0,
                orientation: 'left'
            });
            data = [{
                label: 'symbol',
                value: this.current.symbol
            }, {
                label: 'date',
                value: date_range[1].toDateString()
            }, {
                label: 'value',
                value: this.closestDateValue(date_range[1], this.data)
            }];
            str = data.join("&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;");
            text = d3.select(this.opts.canvas + " .wrapper").selectAll("text.chartinfo").data(data);
            text.html(function(d) {
                return d.value
            }).attr("transform", (function(b) {
                return function(d, i) {
                    var a, offset, q, ref8;
                    offset = b.opts.wrappers[b.current.wrapper].annotation_label ? 120 : 0;
                    for (a = q = 0, ref8 = i; 0 <= ref8 ? q < ref8 : q > ref8; a = 0 <= ref8 ? ++q : --q) {
                        text[0][a].style.display = "block";
                        offset += text[0][a].getComputedTextLength() + 30;
                        text[0][a].style.display = ""
                    }
                    return "translate(" + offset + ",-5)"
                }
            })(this)).style("display", (function(a) {
                return function() {
                    if (a.opts.price_info_on_hover) {
                        return "none"
                    } else {
                        return "block"
                    }
                }
            })(this));
            text.enter().insert("text").html(function(d) {
                return d.value
            }).attr("class", "chartinfo").attr("data-type", function(d) {
                return d.label
            }).attr("transform", (function(b) {
                return function(d, i) {
                    var a, offset, q, ref8;
                    offset = b.opts.wrappers[b.current.wrapper].annotation_label ? 120 : 0;
                    for (a = q = 0, ref8 = i; 0 <= ref8 ? q < ref8 : q > ref8; a = 0 <= ref8 ? ++q : --q) {
                        text[0][a].style.display = "block";
                        offset += text[0][a].getComputedTextLength() + 30;
                        text[0][a].style.display = ""
                    }
                    return "translate(" + offset + ",-5)"
                }
            })(this)).style("display", (function(a) {
                return function() {
                    if (a.opts.price_info_on_hover) {
                        return "none"
                    } else {
                        return "block"
                    }
                }
            })(this));
            text.exit().remove();
            c = this;
            if (!this.transition) {
                this.incrementTransitions();
                this.scales.bottom.draw();
                this.scales.top.draw();
                if (!this.opts.wrappers[this.current.wrapper].labels_disable) {
                    this.scales.left.draw();
                    this.scales.right.draw()
                }
                label = d3.select(this.opts.canvas + " svg").append("g").attr("transform", "translate(0, " + this.opts.margins.top + ")").attr("class", "chartlabel mainlabel");
                label.append("text").text(this.opts.wrappers[this.current.wrapper].label).style("font-size", "10px").style("font-family", "sans-serif").attr("transform", function() {
                    return "translate(" + (c.opts.width + c.opts.margins.left - (c.opts.compatibility_mode ? 100 : this.getComputedTextLength()) - 10) + ",15)"
                });
                label.append("line").attr("stroke", this.opts.colors[0]).attr("stroke-width", 5).attr("x2", 10).attr("y2", 0).attr("transform", function() {
                    var a;
                    a = c.opts.width + c.opts.margins.left - 25;
                    a -= label.select("text")[0][0].getComputedTextLength();
                    return "translate(" + a + ",11)"
                });
                this.decrementTransitions()
            } else {
                this.scales.bottom.draw();
                this.scales.top.draw();
                this.scales.left.draw();
                this.scales.right.draw();
                t = svg.select(".border").transition().duration(this.opts.transition_duration).attr("height", this.opts.height).each("start", this.incrementTransitions).each("end", this.decrementTransitions);
                text = d3.select(".chartlabel.mainlabel text").text(this.opts.wrappers[this.current.wrapper].label).attr("transform", function() {
                    return "translate(" + (c.opts.width + c.opts.margins.left - (c.opts.compatibility_mode ? 100 : this.getComputedTextLength()) - 10) + ",15)"
                });
                d3.select(".chartlabel.mainlabel line").attr("transform", function() {
                    var a;
                    a = c.opts.width + c.opts.margins.left - 25;
                    a -= text[0][0].getComputedTextLength();
                    return "translate(" + a + ",11)"
                })
            }
            x = this.scales.bottom.scalar;
            y = this.scales.right.scalar;
            if (this.current.chart_type === 'line') {
                this.drawLineChart(primary_chart, x, y, this.data, primary_height, null, this.opts.background_color)
            } else if (this.current.chart_type === 'bar') {
                this.drawBarChart(primary_chart, x, y, this.data, primary_height, null, this.opts.background_color)
            }
            if (this.current.secondary_chart_type === 'line') {
                this.drawLineChart(secondary_chart, x, y, this.secondary_data, this.opts.secondary_height * this.opts.height, this.opts.wrappers[this.current.secondary_wrapper].label, this.opts.secondary_background_color)
            } else if (this.current.secondary_chart_type === 'bar') {
                //console.log(this.secondary_data);
                this.drawBarChart(secondary_chart, x, y, this.secondary_data, this.opts.secondary_height * this.opts.height, this.opts.wrappers[this.current.secondary_wrapper].label, this.opts.secondary_background_color)
            } else {
                svg.select('.secondary-chart').remove()
            }
            svg.selectAll(".secondarylabel").remove();
            if (this.current.overlays && this.opts.wrappers[this.current.wrapper].overlays && this.opts.wrappers[this.current.wrapper].overlays.length) {
                layerMap = {};
                scaleCountHasChanged = false;
                ref8 = this.opts.wrappers[this.current.wrapper].overlays;
                for (q = 0, len3 = ref8.length; q < len3; q++) {
                    overlay = ref8[q];
                    layerMap[(overlay.internalKey()) + "-" + (overlay.symbol || this.current.symbol)] = (ref9 = overlay.layer) != null ? ref9 : 1
                }
                layers = d3.set(d3.values(layerMap)).values().sort(function(a, b) {
                    return parseInt(a) - parseInt(b)
                });
                for (idx = u = 0, len4 = layers.length; u < len4; idx = ++u) {
                    layer = layers[idx];
                    layer = parseInt(layer);
                    dataset = this.overlays.filter(function(a) {
                        return layerMap[a[0] + "-" + a[2]] === layer
                    });
                    if (layer === 0) {
                        scale = this.scales.right
                    } else if (idx === 0 || (idx === 1 && layer === 1)) {
                        scale = this.scales.left
                    } else if (this.scales.additional.length >= idx) {
                        scale = this.scales.additional[idx - 1]
                    } else {
                        scale = new PriceChart.Scale({
                            axis: PriceChart.Scale.Y_AXIS,
                            orientation: 'right',
                            chart: this
                        });
                        this.scales.additional.push(scale);
                        scaleCountHasChanged = true;
                        this.opts.margins.right += 50;
                        this.opts.width -= 50
                    }
                    this.drawOverlays(svg, primary_chart, x, dataset, primary_height, scale, layer)
                }
                ref10 = this.scales.additional.slice(layers.length - 1);
                for (idx = z = 0, len5 = ref10.length; z < len5; idx = ++z) {
                    defunctScale = ref10[idx];
                    defunctScale.remove();
                    defunctLayer = layers.length + idx + 1;
                    svg.selectAll("path.overlay[data-layer='" + defunctLayer + "']").remove();
                    scaleCountHasChanged = true;
                    this.opts.margins.right -= 50;
                    this.opts.width += 50
                }
                if (layers[0] !== "0") {
                    svg.selectAll("path.overlay[data-layer='0']").remove()
                }
                this.scales.additional = this.scales.additional.slice(0, layers.length - 1);
                if (scaleCountHasChanged) {
                    this.events.resize()
                }
                if (this.opts.show_legend) {
                    this.drawLegend(svg)
                }
                overlayLabelIsPresent = this.current.overlay_label || this.opts.wrappers[this.current.wrapper].overlay_label;
                labelledOverlays = this.opts.wrappers[this.current.wrapper].overlays.filter((function(b) {
                    return function(a) {
                        return a.showLabel
                    }
                })(this));
                if (overlayLabelIsPresent && labelledOverlays.length === 1) {
                    label = svg.append('g').attr('class', 'secondarylabel');
                    label.append('text').text(this.current.overlay_label || this.opts.wrappers[this.current.wrapper].overlay_label).style('font-family', 'sans-serif').style('font-size', '10px').attr('transform', 'translate(20,15)');
                    key = labelledOverlays[0].internalKey();
                    label.append('line').attr('stroke', (function(a) {
                        return function() {
                            return a.current.lines[key].getAttribute("stroke")
                        }
                    })(this)).attr('stroke-width', 5).attr('x2', 10).attr('y2', 0).attr('transform', 'translate(5,11)')
                }
            } else {
                svg.selectAll("path.overlay").remove();
                svg.selectAll(".legend").remove()
            }
            svg.selectAll("g.tick").style("font-size", "10px").style("font-family", "sans-serif").selectAll("line").attr("stroke", "#000").attr("stroke-width", "1px");
            this.initMouseEvents(svg, x, y);
            if (this.transition_duration === 0) {
                return setTimeout(((function(a) {
                    return function() {
                        return a.events.renderComplete()
                    }
                })(this)), 10)
            }
        };
        PriceChart.prototype.drawLineChart = function(c, x, y, e, f, g, h) {
            var i, line, max, ref, ref1, ref2, ref3, ref4, ref5, trends;
            if (this.opts.wrappers[this.current.wrapper].inverted_axis) {
                y = y.range([y.range()[0], f])
            } else {
                y = y.range([f, y.range()[1]])
            }
            max = void 0;
            line = d3.svg.line().interpolate("linear").x(function(d) {
                return x(d.date)
            }).y(function(d) {
                return y(d.value)
            }).defined((function(b) {
                return function(d) {
                    var a, valid;
                    a = b.opts.wrappers[b.current.wrapper].valid_if;
                    if (typeof a === 'function') {
                        valid = a(d.value)
                    } else {
                        valid = true
                    }
                    valid = valid && d.value !== "N/A" && !isNaN(d.value) && d.date >= x.domain()[0] && d.date <= x.domain()[1];
                    if (valid && ((max == null) || (d.date > max.date))) {
                        max = d
                    }
                    return valid
                }
            })(this));
            if (!this.transition) {
                c.selectAll('*').remove()
            }
            trends = c.selectAll("path.line").data([e]);
            trends.attr("stroke", (function(b) {
                return function(d) {
                    var a;
                    a = b.colorize();
                    b.current.colors.push({
                        color: a,
                        key: d.key
                    });
                    return a
                }
            })(this));
            trends.transition().duration(this.opts.transition_duration).attr("d", function(d) {
                return line(d)
            }).each("start", this.incrementTransitions).each("end", this.decrementTransitions);
            trends.enter().append("path").attr("class", "line").attr("stroke", (function(b) {
                return function(d) {
                    var a;
                    a = b.colorize();
                    b.current.colors.push({
                        color: a,
                        key: d.key
                    });
                    return a
                }
            })(this)).attr("fill", "none").attr("stroke-width", (ref2 = (ref3 = this.opts.line_properties.base) != null ? ref3['stroke-width'] : void 0) != null ? ref2 : this.opts.line_properties["default"]['stroke-width']).attr("stroke-dasharray", (ref = (ref1 = this.opts.line_properties.base) != null ? ref1['stroke-dasharray'] : void 0) != null ? ref : this.opts.line_properties["default"]['stroke-dasharray']).attr("d", function(d) {
                return line(d)
            });
            trends.exit().remove();
            c.selectAll(".linenode").remove();
            this.current.lines['base'] = trends[0][0];
            i = (ref4 = (ref5 = this.opts.line_properties.base) != null ? ref5['node'] : void 0) != null ? ref4 : this.opts.line_properties["default"]['node'];
            if (i) {
                this.drawLineNodes(c, x, y, e, 'base', i)
            }
            d3.select(c.node().parentNode).selectAll(".annotation").remove();
            d3.select(c.node().parentNode).selectAll(".end-value").remove();
            if (this.current.annotations && (this.opts.wrappers[this.current.wrapper].annotation != null)) {
                this.drawAnnotation(this.opts.wrappers[this.current.wrapper].annotation, c, x, y)
            }
            if (this.opts.show_end_values) {
                return this.drawEndValue(c, x, y, max, 'right', this.current.lines.base.getAttribute("stroke"))
            }
        };
        PriceChart.prototype.drawLineNodes = function(a, x, y, b, c, e) {
            var f;
            f = a.selectAll(".linenode[data-line='" + c + "']").data(b.filter(function(d) {
                return !isNaN(d.value) && d.value !== "N/A" && d.date >= x.domain()[0] && d.date <= x.domain()[1]
            }));
            f.enter().append("circle").attr("class", "linenode").attr("data-line", c).attr("cx", function(d) {
                return x(d.date)
            }).attr("cy", function(d) {
                return y(d.value)
            }).attr("r", e).attr("stroke", "none").attr("fill", this.current.lines[c].getAttribute("stroke"));
            return f.exit().remove()
        };
        PriceChart.prototype.drawOverlays = function(c, e, x, f, g, h, k) {
            var n, annotateOpts, d, datapointDisplayOpts, def, internalKeys, inverted_axis, is_valid, j, l, len, len1, len2, len3, line, m, max, o, orientation, overlayDefs, p, ref, ref1, ref2, ref3, ref4, ref5, results, series, trends, value_buffer, value_range, values, y, yMax, yMin;
            values = [];
            max = {};
            for (j = 0, len = f.length; j < len; j++) {
                series = f[j];
                ref = series[1];
                for (l = 0, len1 = ref.length; l < len1; l++) {
                    d = ref[l];
                    is_valid = (d.value != null) && !isNaN(d.value) && d.date >= x.domain()[0] && d.date <= x.domain()[1];
                    if (is_valid && (!max[series[0]] || d.date > max[series[0]].date)) {
                        max[series[0]] = d
                    }
                    if (is_valid) {
                        values.push(d.value)
                    }
                }
            }
            values.sort(function(a, b) {
                return a - b
            });
            yMin = (ref1 = this.opts.ymin_overlay) != null ? ref1 : values[0];
            yMax = (ref2 = this.opts.ymax_overlay) != null ? ref2 : values[values.length - 1];
            value_buffer = (yMax - yMin) * 0.1;
            value_range = [yMin - value_buffer, yMax + value_buffer];
            inverted_axis = !!this.opts.wrappers[this.current.wrapper].overlay_inverted_axis;
            if (inverted_axis === false) {
                internalKeys = (function() {
                    var a, m, results;
                    results = [];
                    for (m = 0, a = f.length; m < a; m++) {
                        o = f[m];
                        results.push(o[0])
                    }
                    return results
                })();
                overlayDefs = (function() {
                    var a, m, ref3, ref4, results;
                    ref3 = this.opts.wrappers[this.current.wrapper].overlays;
                    results = [];
                    for (m = 0, a = ref3.length; m < a; m++) {
                        o = ref3[m];
                        if (ref4 = o.internalKey(), indexOf.call(internalKeys, ref4) >= 0) {
                            results.push(o)
                        }
                    }
                    return results
                }).call(this);
                for (m = 0, len2 = overlayDefs.length; m < len2; m++) {
                    def = overlayDefs[m];
                    if (def.invertedAxis) {
                        inverted_axis = true;
                        break
                    }
                }
            }
            if (k !== 0) {
                h.update({
                    domain: value_range,
                    range: inverted_axis ? [0, g] : [g, 0],
                    type: PriceChart.Scale.LINEAR_SCALE,
                    tickCount: 8
                });
                h.draw()
            }
            y = h.scalar;
            line = d3.svg.line().interpolate("linear").x(function(d) {
                return x(d.date)
            }).y(function(d) {
                return y(d.value)
            }).defined(function(d) {
                return !isNaN(d.value) && d.value !== "N/A" && d.date >= x.domain()[0] && d.date <= x.domain()[1]
            });
            if (!this.transition) {
                e.selectAll("path.overlay[data-layer='" + k + "']").remove()
            }
            trends = e.selectAll("path.overlay[data-layer='" + k + "']").data(f);
            n = this;
            trends.transition().duration(this.opts.transition_duration).attr("d", function(d) {
                return line(d[1])
            }).attr("stroke", (function(b) {
                return function(d) {
                    var a;
                    a = b.colorize(d[0], d[2]);
                    b.current.colors.push({
                        color: a,
                        key: d[0]
                    });
                    return a
                }
            })(this)).attr("stroke-width", (function(b) {
                return function(d) {
                    var a, ref4;
                    return (a = (ref4 = b.opts.line_properties[d[0]]) != null ? ref4['stroke-width'] : void 0) != null ? a : b.opts.line_properties["default"]['stroke-width']
                }
            })(this)).attr("stroke-dasharray", (function(b) {
                return function(d) {
                    var a, ref4;
                    return (a = (ref4 = b.opts.line_properties[d[0]]) != null ? ref4['stroke-dasharray'] : void 0) != null ? a : b.opts.line_properties["default"]['stroke-dasharray']
                }
            })(this)).attr("data-layer", k).each("start", this.incrementTransitions).each("end", this.decrementTransitions).each(function(d, i) {
                return n.current.lines[d[0]] = this
            });
            trends.enter().append("path").attr("class", "overlay").attr("stroke", (function(b) {
                return function(d) {
                    var a;
                    a = b.colorize(d[0], d[2]);
                    b.current.colors.push({
                        color: a,
                        key: d[0]
                    });
                    return a
                }
            })(this)).attr("fill", "none").attr("stroke-width", (function(b) {
                return function(d) {
                    var a, ref4;
                    return (a = (ref4 = b.opts.line_properties[d[0]]) != null ? ref4['stroke-width'] : void 0) != null ? a : b.opts.line_properties["default"]['stroke-width']
                }
            })(this)).attr("stroke-dasharray", (function(b) {
                return function(d) {
                    var a, ref4;
                    return (a = (ref4 = b.opts.line_properties[d[0]]) != null ? ref4['stroke-dasharray'] : void 0) != null ? a : b.opts.line_properties["default"]['stroke-dasharray']
                }
            })(this)).attr("data-layer", k).attr("d", function(d) {
                return line(d[1])
            }).each(function(d, i) {
                return n.current.lines[d[0]] = this
            });
            trends.exit().remove();
            results = [];
            for (p = 0, len3 = f.length; p < len3; p++) {
                series = f[p];
                datapointDisplayOpts = (ref3 = (ref4 = this.opts.line_properties[series[0]]) != null ? ref4['node'] : void 0) != null ? ref3 : this.opts.line_properties["default"]['node'];
                if (datapointDisplayOpts) {
                    this.drawLineNodes(e, x, y, series[1], series[0], datapointDisplayOpts)
                }
                if (((ref5 = this.getOverlayOpts(series[0])) != null ? ref5['annotation'] : void 0) != null) {
                    annotateOpts = this.getOverlayOpts(series[0]);
                    this.drawAnnotation(annotateOpts.annotation, e, x, y, series[1], series[1], annotateOpts.annotation_formatter)
                }
                if (this.opts.show_end_values) {
                    orientation = k === 1 ? 'left' : 'right';
                    results.push(setTimeout((function(b) {
                        return function(a) {
                            return function() {
                                return b.drawEndValue(e, x, y, max[a[0]], orientation, b.current.lines[a[0]].getAttribute("stroke"), h.layer)
                            }
                        }
                    })(this)(series), this.opts.transition_duration))
                } else {
                    results.push(void 0)
                }
            }
            return results
        };
        PriceChart.prototype.getOverlayOpts = function(a, b) {
            var j, len, overlay, ref;
            ref = this.opts.wrappers[this.current.wrapper].overlays;
            for (j = 0, len = ref.length; j < len; j++) {
                overlay = ref[j];
                if (b && overlay.symbol) {
                    if (overlay.internalKey() === a && overlay.symbol === b) {
                        return overlay
                    }
                } else {
                    if (overlay.internalKey() === a) {
                        return overlay
                    }
                }
            }
        };
        PriceChart.prototype.drawBarChart = function(b, x, y, c, e, f, g) {
            var h, bars, d, data_percent_of_domain_used, data_width, date, i, j, len, scale, scale_modified, v, value_buffer, value_range, width, yAxis;
            b.selectAll('*').remove();
            if (b.attr("class") === "secondary-chart") {
                b.append("rect").attr("fill", g instanceof PriceChart.GradientGenerator ? "url(#" + g.id + ")" : g).attr("height", 0).attr("width", this.opts.width - 1).attr("transform", "translate(1,0)").transition().duration(this.opts.transition_duration).attr("height", e).attr("fill", g instanceof PriceChart.GradientGenerator ? "url(#" + g.id + ")" : g).each("start", this.incrementTransitions).each("end", this.decrementTransitions)
            }
            value_range = [2e308, -2e308];
            c = (function() {
                var j, len, results;
                results = [];
                for (j = 0, len = c.length; j < len; j++) {
                    i = c[j];
                    if (!this._isValid(i)) {
                        continue
                    }
                    results.push(i)
                }
                return results
            }).call(this);
            for (j = 0, len = c.length; j < len; j++) {
                d = c[j];
                v = d.value;
                if (v > value_range[1]) {
                    value_range[1] = v
                }
                if (v < value_range[0]) {
                    value_range[0] = v
                }
            }
                        
            value_buffer = (value_range[1] - value_range[0]) * 0.1;
            value_range = [value_range[0], value_range[1] + value_buffer];
            data_width = c[0].date - x.domain()[0];
            data_percent_of_domain_used = data_width / (x.domain()[1] - x.domain()[0]);
            width = (this.opts.width * data_percent_of_domain_used) / c.length;
            h = d3.scale.linear().domain(value_range).range([0, e]);
            bars = b.selectAll("rect.bar").data(c);
            scale_modified = false;
            while (x(c[c.length - 1].date) < ((width * this.opts.bar_spacing) / 2)) {
                date = x.domain()[0];
                date.setDate(date.getDate() - 1);
                x.domain([date, x.domain()[1]]);
                scale_modified = true
            }
            while (x(c[0].date) + ((width * this.opts.bar_spacing) / 2) > x(x.domain()[1])) {
                date = x.domain()[1];
                date.setDate(date.getDate() + 1);
                x.domain([x.domain()[0], date]);
                scale_modified = true
            }
            if (scale_modified) {
                this.scales.bottom.update({
                    domain: x.domain()
                });
                this.scales.bottom.draw()
            }
            bars.enter().append("rect").attr("class", "bar").attr("x", (function(a) {
                return function(d) {
                    return x(d.date) - ((width * a.opts.bar_spacing) / 2)
                }
            })(this)).attr("y", e).attr("height", 0).attr("width", width - (width * this.opts.bar_spacing)).attr("fill", this.opts.bar_color);
            bars.exit().remove();
            bars.transition().duration(this.opts.transition_duration).attr("height", function(d) {
                return h(d.value)
            }).attr("y", function(d) {
                return e - h(d.value)
            }).each("start", this.incrementTransitions).each("end", this.decrementTransitions);
            b.select(".chartlabel").remove();
            if (f) {
                b.append("g").attr("class", "chartlabel").attr("transform", "translate(10,15)").append("text").text(f).attr("fill", "#0F75BC").style("font-size", "12px").style("font-family", "sans-serif")
            }
            if (b.attr("class") === "secondary-chart") {
                b.select(".y.axis").remove();
                scale = d3.scale.linear().domain(value_range).range([e, 0]);
                yAxis = d3.svg.axis().scale(scale).ticks(5).orient("right");
                return b.append("g").attr("class", "y axis left").attr("transform", "translate(" + (this.opts.width - 1) + ", 0)").call(yAxis).selectAll("path, line").attr("fill", "none").attr("shape-rendering", "crispEdges")
            }
        };
        PriceChart.prototype.drawAnnotation = function(c, e, x, y, f, g, h) {
            var i, d, fn, j, l, legend, len, len1, offset, ref, results, text, val;
            if (f == null) {
                f = this.annotations
            }
            if (g == null) {
                g = this.data
            }
            if (h == null) {
                h = this.annotation_formatter
            }
            fn = (function(b) {
                return function(d) {
                    var a, n, ref, ref1, ref2, ref3, ref4;
                    a = c(d.value);
                    if ((a != null) && !isNaN(d.value) && (((ref1 = (ref2 = b.current.date_range[0]) != null ? ref2.getTime() : void 0) != null ? ref1 : -2e308) <= (ref = d.date.getTime()) && ref <= ((ref3 = (ref4 = b.current.date_range[1]) != null ? ref4.getTime() : void 0) != null ? ref3 : 2e308)) && y(b.closestDateValue(d.date, g)) > 0) {
                        n = e.append("g").attr("class", "annotation").attr("transform", "translate(" + (x(d.date) - a.width / 2) + ", " + (y(b.closestDateValue(d.date, g)) + (a.height <= 0 ? 0 : -a.height - 0)) + ")").append("path").attr("d", a.path).attr("stroke", a.stroke).attr("stroke-width", a.strokewidth).attr("fill", a.fill);
                        if (h) {
                            return n.on('mouseover', function() {
                                return b.showTooltip(h({
                                    date: d.date,
                                    value: d.value
                                }, b))
                            }).on('mousemove', b.moveTooltip).on('mouseout', b.hideTooltip)
                        }
                    }
                }
            })(this);
            for (j = 0, len = f.length; j < len; j++) {
                d = f[j];
                fn(d)
            }
            if (this.opts.wrappers[this.current.wrapper].annotation_label) {
                legend = d3.select(this.opts.canvas + " g.wrapper").append("g").attr("class", "annotation");
                text = legend.append('text').text(this.opts.wrappers[this.current.wrapper].annotation_label).attr('class', 'annotation').style('font-family', 'sans-serif').style('font-size', '12px').attr('transform', 'translate(0, -3)');
                if (this.opts.wrappers[this.current.wrapper].annotation_legend_values) {
                    offset = text.node().getComputedTextLength();
                    ref = this.opts.wrappers[this.current.wrapper].annotation_legend_values;
                    results = [];
                    for (l = 0, len1 = ref.length; l < len1; l++) {
                        val = ref[l];
                        i = this.opts.wrappers[this.current.wrapper].annotation(val);
                        legend.append("g").attr("class", "annotation").attr("transform", "translate(" + offset + ", " + (i.height > 0 ? -i.height : i.height) + ")").append("path").attr("d", i.path).attr("stroke", i.stroke).attr("stroke-width", i.strokewidth).attr("fill", i.fill);
                        results.push(offset += i.width)
                    }
                    return results
                }
            }
        };
        PriceChart.prototype.drawLegend = function(b) {
            var c, j, k, key, label, legend, legendNode, len, offset, ref, ref1, ref2, ref3, ref4, x;
            b.selectAll(".legend").remove();
            legend = b.append('g').attr('class', 'legend').attr('width', this.opts.width).attr('transform', 'translate(0, -2)');
            offset = this.opts.width;
            ref = ((function() {
                var a;
                a = [];
                for (k in this.current.lines) {
                    a.push(k)
                }
                return a
            }).call(this)).reverse();
            for (j = 0, len = ref.length; j < len; j++) {
                key = ref[j];
                if (key !== 'base') {
                    c = (ref1 = (ref2 = (function() {
                        var l, len1, ref3, results;
                        ref3 = this.current.colors;
                        results = [];
                        for (l = 0, len1 = ref3.length; l < len1; l++) {
                            x = ref3[l];
                            if (x.key === key) {
                                results.push(x)
                            }
                        }
                        return results
                    }).call(this)) != null ? (ref3 = ref2[0]) != null ? ref3.color : void 0 : void 0) != null ? ref1 : '#000000';
                    label = ((function() {
                        var l, len1, ref4, results;
                        ref4 = this.opts.wrappers[this.current.wrapper].overlays;
                        results = [];
                        for (l = 0, len1 = ref4.length; l < len1; l++) {
                            x = ref4[l];
                            if (x.internalKey() === key) {
                                results.push(x)
                            }
                        }
                        return results
                    }).call(this))[0].label;
                    legendNode = legend.append('g');
                    legendNode.append('rect').attr('x', 4).attr('y', -12).attr('width', 9).attr('height', 9).attr('fill', c);
                    legendNode.append('text').text(label).attr('x', 17).attr('y', -3).style("font-size", "12px").style("font-family", "sans-serif").attr("fill", c);
                    offset = offset - 20 - legendNode.select('text')[0][0].getComputedTextLength();
                    legendNode.attr('transform', "translate(" + offset + ", 0)")
                }
            }
            return legend.append('text').text((ref4 = this.opts.wrappers[this.current.wrapper].legend_label) != null ? ref4 : '').style('font-size', '12px').style('font-family', 'sans-serif').attr('transform', function() {
                return "translate(" + (offset - this.getComputedTextLength() - 10) + ", -3)"
            })
        };
        PriceChart.prototype.showTooltip = function(a) {
            return this.tooltip.style('display', 'block').html(a)
        };
        PriceChart.prototype.moveTooltip = function() {
            var a, rect, ref, ref1, ref2, ref3;
            rect = d3.select(this.opts.canvas).node().getBoundingClientRect();
            a = d3.event;
            return this.tooltip.style("top", (((ref2 = a.pageY) != null ? ref2 : a.clientY) - rect.top - ((ref3 = window.scrollY) != null ? ref3 : window.pageYOffset) - 10) + "px").style("left", (((ref = a.pageX) != null ? ref : a.clientX) - rect.left - ((ref1 = window.scrollX) != null ? ref1 : window.pageXOffset) + 10) + "px")
        };
        PriceChart.prototype.hideTooltip = function() {
            return this.tooltip.style('display', 'none')
        };
        PriceChart.prototype.closestDateValue = function(a, b) {
            var c, best_value, d, j, len, max_date, max_value;
            c = null;
            best_value = null;
            max_date = new Date(0);
            max_value = null;
            for (j = 0, len = b.length; j < len; j++) {
                d = b[j];
                if (d.date >= a) {
                    c = d.date;
                    best_value = d.value
                }
                if (d.date >= max_date) {
                    max_date = d.date;
                    max_value = d.value
                }
            }
            return best_value != null ? best_value : max_value
        };
        PriceChart.prototype.parseDate = function(a) {
            var b, date_parts;
            if (a instanceof Date) {
                return a
            }
            date_parts = a.split('/');
            date_parts[2] = parseInt(date_parts[2], 10) > 50 ? "19" + date_parts[2] : "20" + date_parts[2];
            b = new Date(date_parts[2], parseInt(date_parts[0] - 1, 10), date_parts[1]);
            if ((this._current_period != null) && this._current_period === 'monthly') {
                b.setDate(1)
            } else if ((this._current_period != null) && this._current_period === 'weekly') {
                b.setDate(b.getDate() - 7)
            }
            return b
        };
        PriceChart.prototype.titleize = function(b) {
            return b.replace(/_/g, ' ').replace(/\w\S*/g, function(a) {
                return a.charAt(0).toUpperCase() + a.substr(1).toLowerCase()
            })
        };
        PriceChart.prototype._isValid = function(d) {
            return (d.value != null) && !(d.value === "N/A" || isNaN(d.value) || ((this.current.date_range[0] != null) && d.date < this.current.date_range[0]) || ((this.current.date_range[1] != null) && d.date > this.current.date_range[1]))
        };
        PriceChart.prototype.save = function() {
            var a, xml;
            if (this.opts.png_convert_endpoint) {
                if (this.opts.price_info_on_hover) {
                    d3.selectAll(this.opts.canvas + " text.chartinfo").style("display", "block")
                }
                xml = (new XMLSerializer).serializeToString(d3.select(this.opts.canvas + " svg").node());
                if (this.opts.price_info_on_hover) {
                    d3.selectAll(this.opts.canvas + " text.chartinfo").style("display", "none")
                }
                a = d3.select(this.opts.canvas).append('form').attr('action', this.opts.png_convert_endpoint).attr('method', 'post');
                a.append('input').attr('type', 'hidden').attr('name', 'svg').attr('value', encodeURIComponent(xml));
                a.append('input').attr('type', 'hidden').attr('name', 'width').attr('value', this.opts.width + this.opts.margins.left + this.opts.margins.right);
                a.append('input').attr('type', 'hidden').attr('name', 'height').attr('value', this.opts.height + this.opts.margins.top + this.opts.margins.bottom);
                a.append('input').attr('type', 'hidden').attr('name', 'symbol').attr('value', this.current.symbol);
                a.append('input').attr('type', 'hidden').attr('name', 'wrapper').attr('value', this.current.wrapper);
                a.append('input').attr('type', 'hidden').attr('name', 'period').attr('value', this.current.period);
                a.append('input').attr('type', 'hidden').attr('name', 'from_date').attr('value', this.current.date_range[0]);
                a.append('input').attr('type', 'hidden').attr('name', 'to_date').attr('value', this.current.date_range[1]);
                a.append('input').attr('type', 'hidden').attr('name', 'chart_type').attr('value', this.current.chart_type);
                a.append('input').attr('type', 'hidden').attr('name', 'secondary_chart_type').attr('value', this.current.secondary_chart_type);
                a.append('input').attr('type', 'hidden').attr('name', 'secondary_wrapper').attr('value', this.current.secondary_wrapper);
                a.append('input').attr('type', 'hidden').attr('name', 'annotations').attr('value', this.current.annotations);
                a.append('input').attr('type', 'hidden').attr('name', 'overlays').attr('value', this.current.overlays);
                return a.node().submit()
            } else {
                throw "Cannot save, no conversion endpoint defined";
            }
        };
        PriceChart.prototype.abort = function(a) {
            if (a) {
                this.error = a
            }
            this.destroy();
            console.error("Chart error: " + this.error);
            if (this.opts.error_image) {
                this.resetErrors();
                d3.select(this.opts.canvas).append('img').attr('src', this.opts.error_image).attr('height', this.opts.height).attr('width', this.opts.width).attr('class', 'price-chart-error-image')
            } else {
                d3.select(this.opts.canvas).append('div').attr('class', 'error').text(this.error)
            }
            return this.events.error()
        };
        PriceChart.prototype.resetErrors = function() {
            return d3.select(this.opts.canvas).selectAll('img.price-chart-error-image').remove()
        };
        PriceChart.prototype.destroy = function() {
            this.events.destroy();
            this.resetColors();
            return d3.select(this.opts.canvas).select('svg').remove()
        };
        PriceChart.prototype.createEmptyWrapper = function(a) {
            return this.opts.wrappers[a] = {
                key: a,
                api_key: a,
                label: this.titleize(a),
                periodicity: true
            }
        };
        PriceChart.prototype.idealTextColor = function(a) {
            var b, delta, g, r, threshold;
            threshold = 105;
            r = parseInt(a.substring(1, 3), 16);
            g = parseInt(a.substring(3, 5), 16);
            b = parseInt(a.substring(5, 6), 16);
            delta = (r * 0.299) + (g * 0.587) + (b * 0.114);
            if (255 - delta < threshold) {
                return "#000000"
            } else {
                return "#FFFFFF"
            }
        };
        PriceChart.prototype.drawEndValue = function(a, x, y, b, c, d, e) {
            var f, g, ref, ref1, ref2, ref3, tag, text;
            if (e == null) {
                e = 0
            }
            if (!b) {
                return
            }
            a = d3.select(a.node().parentNode);
            if (c === "right") {
                g = a.append("g").attr("class", "end-value");
                tag = g.append("polygon").attr("fill", d);
                if (this.opts.end_value_style === PriceChart.Config.END_VALUE_STYLE__VALUES) {
                    text = g.append("text").text(b.value.toFixed(2)).attr("fill", this.idealTextColor(d)).style("font-size", "10px").style("font-family", "sans-serif");
                    f = this.opts.end_value_function.right(text[0][0].getComputedTextLength());
                    text.attr("transform", "translate(" + (10 + ((ref = f.textOffsetLeft) != null ? ref : 0)) + "," + (11 + ((ref1 = f.textOffsetTop) != null ? ref1 : 0)) + ")")
                } else if (this.opts.end_value_style === PriceChart.Config.END_VALUE_STYLE__SOLID) {
                    f = this.opts.end_value_function.right(0)
                }
                tag.attr("points", f.path);
                return g.attr("transform", "translate(" + (x.range()[1] + (45 * e)) + "," + (y(b.value) - (f.height / 2)) + ")")
            } else {
                g = a.append("g").attr("class", "end-value");
                tag = g.append("polygon").attr("fill", d);
                if (this.opts.end_value_style === PriceChart.Config.END_VALUE_STYLE__VALUES) {
                    text = g.append("text").text(b.value >= 1000 ? b.value : b.value.toFixed(2)).attr("fill", this.idealTextColor(d)).style("font-size", "10px").style("font-family", "sans-serif");
                    f = this.opts.end_value_function.left(text[0][0].getComputedTextLength());
                    text.attr("transform", "translate(" + (3 + ((ref2 = f.textOffsetLeft) != null ? ref2 : 0)) + "," + (11 + ((ref3 = f.textOffsetTop) != null ? ref3 : 0)) + ")")
                } else {
                    f = this.opts.end_value_function.left(0)
                }
                tag.attr("points", f.path);
                return g.attr("transform", "translate(-" + f.width + "," + (y(b.value) - (f.height / 2)) + ")")
            }
        };
        PriceChart.prototype.parseColorOption = function(a) {
            if (a) {
                if (Array.isArray(a)) {
                    return new PriceChart.GradientGenerator(a[0], a[1])
                } else {
                    return a
                }
            }
        };
        PriceChart.prototype.dataFormatter = function(a, b) {
            if (this.opts.wrappers[this.current.wrapper].data_formatter) {
                return this.opts.wrappers[this.current.wrapper].data_formatter.bind(this)(a, b)
            } else {
                return this.opts.data_formatter.bind(this)(a, b)
            }
        };
        PriceChart.prototype.incrementTransitions = function() {
            return this.transitionCount += 1
        };
        PriceChart.prototype.decrementTransitions = function() {
            this.transitionCount -= 1;
            if (this.transitionCount === 0) {
                return setTimeout(((function(a) {
                    return function() {
                        return a.events.renderComplete()
                    }
                })(this)), 1)
            }
        };
        return PriceChart
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.Config = (function() {
        function Config() {}
        Config.END_VALUE_STYLE__VALUES = 1;
        Config.END_VALUE_STYLE__SOLID = 2;
        Config.END_VALUE_FUNCTION__LEFT_SIDE = function(a) {
            return {
                height: 15,
                width: a + 15,
                textOffsetLeft: 0,
                textOffsetTop: 0,
                path: "0,0 " + (a + 8) + ",0 " + (a + 15) + ",7 " + (a + 8) + ",15 0,15 0,0"
            }
        };
        Config.END_VALUE_FUNCTION__RIGHT_SIDE = function(a) {
            return {
                height: 15,
                width: a + 15,
                textOffsetLeft: 0,
                textOffsetTop: 0,
                path: "0,7 7,0 " + (a + 15) + ",0 " + (a + 15) + ",15 7,15, 0,7"
            }
        };
        Config.parse = function(a, b) {
            var j, len, objScope, part, parts;
            if (b == null) {
                b = null
            }
            if (a == null) {
                return b
            }
            if (typeof a === 'number') {
                return a
            } else if (typeof a === 'string' || a instanceof String) {
                parts = a.split('.');
                objScope = window;
                for (j = 0, len = parts.length; j < len; j++) {
                    part = parts[j];
                    objScope = objScope[part]
                }
                return objScope
            } else {
                throw "Parse received unknown option " + a;
            }
        };
        return Config
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.Dataset = (function() {
        Dataset.sourceUrl = null;
        Dataset.currentSource = null;
        Dataset.prototype.data = [];

        function Dataset(a) {
            var b;
            if (a == null) {
                a = {}
            }
            this.chart = a.instance;
            this.sourceUrl = (function() {
                if ((b = a.sourceUrl) != null) {
                    return b
                } else {
                    throw "Undefined data source";
                }
            })()
        }
        Dataset.prototype.parseData = function(a, b, c) {
            var d, date, k, ref, series, v, value;
            d = [];
            if (a[c]) {
                series = (ref = a[c][b]) != null ? ref : a[c][this.chart.current.period + "_" + b]
            }
            if (series != null) {
                for (k in series) {
                    v = series[k];
                    date = this.chart.parseDate(k);
                    value = parseFloat(v);
                    if (!isNaN(v)) {
                        d.push({
                            date: this.chart.parseDate(k),
                            value: parseFloat(v)
                        })
                    }
                }
            } else {
                this.chart.abort("Parse error: Could not find key " + b + " in data");
                return
            }
            return d
        };
        Dataset.prototype.fetch = function(d, e, f) {
            var g, url;
            url = this.sourceUrl.replace("{WRAPPER}", d).replace("{SYMBOL}", e);
            if (g = this.find(PriceChart.APIDataObject, url)) {
                return f(g.getJSON())
            } else {
                this.currentSource = url;
                return d3.json(url, (function(c) {
                    return function(a, b) {
                        if (c.currentSource === url) {
                            if (a) {
                                c.chart.abort("Error retrieving data: " + a.responseText);
                                return
                            }
                            if (b['Error']) {
                                c.chart.abort("Error retrieving data: " + b['Error']);
                                return
                            }
                            g = new PriceChart.APIDataObject(url, b, e);
                            c.data.push(g);
                            return f(g.getJSON())
                        }
                    }
                })(this))
            }
        };
        Dataset.prototype.find = function(a, b) {
            var c, j, len, ref;
            ref = this.data;
            for (j = 0, len = ref.length; j < len; j++) {
                c = ref[j];
                if (c instanceof a && c.key === b) {
                    return c
                }
            }
        };
        Dataset.prototype.getJSON = function(a, b) {
            var c, url;
            url = this.sourceUrl.replace("{WRAPPER}", a).replace("{SYMBOL}", b);
            return (c = this.find(PriceChart.APIDataObject, url)) != null ? c.getJSON() : void 0
        };
        Dataset.prototype.findAPIDataObject = function(a, b) {
            var c, ref, ref1, ref2, url;
            c = (ref = (ref1 = this.chart.opts.wrappers[a.key]) != null ? ref1.api_key : void 0) != null ? ref : a.key;
            url = this.sourceUrl.replace("{WRAPPER}", c).replace("{SYMBOL}", b);
            return (ref2 = this.find(PriceChart.APIDataObject, url)) != null ? ref2.getJSON() : void 0
        };
        Dataset.prototype.findOrCreateComputedMovingAverage = function(c, d) {
            var e, key;
            key = d + "_" + c.key + "_" + c.movingAveragePeriod + "_day_moving_average";
            if (e = this.find(PriceChart.ComputedMovingAverageDataObject, key)) {
                return e.getData()
            } else {
                this.fetch(c.key, d, (function(b) {
                    return function(a) {
                        b.data.push(new PriceChart.ComputedMovingAverageDataObject(c.key, b.parseData(a, c.key, d), c.movingAveragePeriod, d));
                        return b.chart.update()
                    }
                })(this));
                return false
            }
        };
        return Dataset
    })();
    PriceChart.APIDataObject = (function() {
        APIDataObject.prototype.key = void 0;
        APIDataObject.prototype.symbol = void 0;
        APIDataObject.prototype.json = {};

        function APIDataObject(a, b, c) {
            this.key = a;
            this.json = b;
            this.symbol = c
        }
        APIDataObject.prototype.getJSON = function() {
            var a;
            a = {};
            a[this.symbol] = this.json;
            return a
        };
        APIDataObject.prototype.key = function() {
            return this.key
        };
        return APIDataObject
    })();
    PriceChart.ComputedMovingAverageDataObject = (function() {
        ComputedMovingAverageDataObject.prototype.key = void 0;
        ComputedMovingAverageDataObject.prototype.symbol = void 0;
        ComputedMovingAverageDataObject.prototype.data = [];

        function ComputedMovingAverageDataObject(a, b, c, d) {
            this.symbol = d;
            this.key = d + "_" + a + "_" + c + "_day_moving_average";
            this.computeMovingAverage(b, c)
        }
        ComputedMovingAverageDataObject.prototype.computeMovingAverage = function(c, d) {
            var e, datapoint, j, len, windowCloseDate, windowCloseIndex, windowOpenDate, windowOpenIndex;
            this.data = [];
            c.sort(function(a, b) {
                if (a.date.getTime() > b.date.getTime()) {
                    return 1
                }
                if (a.date.getTime() < b.date.getTime()) {
                    return -1
                }
                return 0
            });
            for (j = 0, len = c.length; j < len; j++) {
                datapoint = c[j];
                e = datapoint.date;
                windowOpenDate = new Date(e.getTime());
                windowOpenDate.setDate(windowOpenDate.getDate() - Math.ceil(d / 2));
                windowCloseDate = new Date(e.getTime());
                windowCloseDate.setDate(windowCloseDate.getDate() + Math.ceil(d / 2));
                windowOpenIndex = this.indexOfLastDateBefore(c, windowOpenDate);
                windowCloseIndex = this.indexOfLastDateBefore(c, windowCloseDate);
                this.data.push({
                    date: e,
                    value: this.averageBetweenIndices(c, windowOpenIndex, windowCloseIndex)
                })
            }
            return this.data
        };
        ComputedMovingAverageDataObject.prototype.indexOfLastDateBefore = function(a, b, c) {
            var d;
            d = c != null ? c : 0;
            while (a[d] && a[d].date.getTime() < b.getTime()) {
                d += 1
            }
            return d
        };
        ComputedMovingAverageDataObject.prototype.averageBetweenIndices = function(c, d, e) {
            var f, sum;
            f = c.slice(d, e + 1);
            sum = f.reduce((function(a, b) {
                return a += b.value
            }), 0);
            return sum / f.length
        };
        ComputedMovingAverageDataObject.prototype.getData = function() {
            return this.data
        };
        ComputedMovingAverageDataObject.prototype.key = function() {
            return this.key
        };
        return ComputedMovingAverageDataObject
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.DrawMode = (function() {
        DrawMode.chart = null;
        DrawMode.drag = null;
        DrawMode.container = null;
        DrawMode.selection = null;
        DrawMode.trendlines = [];
        DrawMode.current = null;

        function DrawMode(a) {
            var b;
            this.chart = a;
            this.drag = d3.behavior.drag();
            b = d3.select(a.opts.canvas).select("rect.border");
            this.container = d3.select(b.node().parentNode).append("g").attr("class", "draw-mode-group");
            this.selection = this.container.append("rect");
            this.selection.attr("class", "draw-mode-selection").attr("height", b.attr("height")).attr("width", b.attr("width")).attr("fill", "transparent");
            this.selection.call(this.drag);
            this.drag.on("dragstart", this.dragStart.bind(this));
            this.drag.on("drag", this.dragMove.bind(this));
            this.drag.on("dragend", this.dragEnd.bind(this));
            this.trendlines = [];
            this.setStyles()
        }
        DrawMode.prototype.destroy = function() {
            var j, len, ref, trendline;
            this.selection.on(".drag", null);
            ref = this.trendlines;
            for (j = 0, len = ref.length; j < len; j++) {
                trendline = ref[j];
                trendline.destroy()
            }
            this.trendlines = [];
            this.selection.remove();
            return this.clearStyles()
        };
        DrawMode.prototype.dragStart = function() {
            var a, trendline, width;
            if (d3.event.sourceEvent.button === 0) {
                width = (a = this.chart.opts.draw_mode_default_width) != null ? a : 1;
                trendline = new PriceChart.TrendLine(this.chart, {
                    container: this.container,
                    width: width
                });
                trendline.beginDrag();
                this.trendlines.push(trendline);
                return this.current = trendline
            } else {
                return this.current = null
            }
        };
        DrawMode.prototype.dragMove = function() {
            if (this.current) {
                if (!this.current.element) {
                    this.current.set({
                        x1: d3.event.x,
                        y1: d3.event.y
                    })
                }
                return this.current.set({
                    x2: d3.event.x,
                    y2: d3.event.y
                })
            }
        };
        DrawMode.prototype.dragEnd = function() {
            if (this.current) {
                this.current.endDrag();
                this.current.draw();
                return this.current = null
            }
        };
        DrawMode.prototype.setStyles = function() {
            return this.container.attr("style", "cursor:crosshair")
        };
        DrawMode.prototype.clearStyles = function() {
            return this.container.attr("style", null)
        };
        return DrawMode
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.GradientGenerator = (function() {
        GradientGenerator.id = 0;

        function GradientGenerator(a, b) {
            this.c1 = a;
            this.c2 = b;
            this.id = "gradient" + PriceChart.GradientGenerator.id;
            PriceChart.GradientGenerator.id += 1
        }
        GradientGenerator.prototype.generate = function(a) {
            var b;
            b = a.append("linearGradient");
            b.attr("id", this.id).attr("x1", "50%").attr("y1", "0%").attr("x2", "50%").attr("y2", "100%").attr("spreadMethod", "pad");
            b.append("stop").attr("offset", "0%").attr("stop-color", this.c1).attr("stop-opacity", 1);
            b.append("stop").attr("offset", "50%").attr("stop-color", this.c2).attr("stop-opacity", 1);
            return b.append("stop").attr("offset", "100%").attr("stop-color", this.c2).attr("stop-opacity", 1)
        };
        return GradientGenerator
    })();
    d3.contextMenu = function(g) {
        d3.selectAll(".chart-context-menu").data([1]).enter().append("div").attr("class", "chart-context-menu").style("position", "absolute").style("display", "none").style("z-index", "999");
        d3.select("body").on("click", function() {
            return d3.select(".chart-context-menu").style("display", "none")
        });
        return (function(f) {
            return function(b, c) {
                var e;
                d3.selectAll(".chart-context-menu").html("");
                e = d3.selectAll(".chart-context-menu").append("ul");
                e.selectAll("li").data(g).enter().append("li").html(function(d) {
                    var a;
                    return (a = d.label) != null ? a : d.html
                }).attr("class", function(d) {
                    if (d.label) {
                        return "clickable"
                    }
                }).on("click", function(d, i) {
                    d.action(f, b, c);
                    return d3.select(".chart-context-menu").style("display", "none")
                });
                d3.select(".chart-context-menu").style("left", (d3.event.pageX - 2) + "px").style("top", (d3.event.pageY - 2) + "px").style("display", "block");
                return d3.event.preventDefault()
            }
        })(this)
    };
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.OverlayDefinition = (function() {
        OverlayDefinition.chart = null;
        OverlayDefinition.opts = {};
        OverlayDefinition.key = null;
        OverlayDefinition.label = null;
        OverlayDefinition.annotation = null;
        OverlayDefinition.annotationKey = null;
        OverlayDefinition.annotationFormatter = null;
        OverlayDefinition.type = null;
        OverlayDefinition.layer = null;
        OverlayDefinition.symbol = null;
        OverlayDefinition.color = null;
        OverlayDefinition.invertedAxis = null;
        OverlayDefinition.showLabel = false;

        function OverlayDefinition(a, b) {
            var c;
            if (b == null) {
                b = {}
            }
            this.chart = a;
            this.opts = b;
            this.key = b.key;
            this.label = b.label;
            this.annotation = b.annotation;
            this.annotationKey = b.annotation_key;
            this.annotationFormatter = b.annotation_formatter;
            this.layer = b.layer;
            this.symbol = b.symbol;
            this.color = b.color;
            this.invertedAxis = (c = b.inverted_axis) != null ? c : false;
            this.showLabel = !b.layer || b.layer === 1 || b.show_label;
            this.type = this.getType(b.type);
            if (this.type === PriceChart.ComputedMovingAverageDataObject) {
                b.moving_avg_days = parseInt(b.moving_average_days, 10);
                this.movingAveragePeriod = b.moving_average_days
            }
        }
        OverlayDefinition.prototype.getType = function(a) {
            if (a === "computed_moving_average") {
                return PriceChart.ComputedMovingAverageDataObject
            } else {
                return PriceChart.APIDataObject
            }
        };
        OverlayDefinition.prototype.internalKey = function() {
            var a, symbol;
            symbol = (a = this.symbol) != null ? a : this.chart.current.symbol;
            if (this.type === PriceChart.ComputedMovingAverageDataObject) {
                return symbol + "_" + this.key + "_cma_" + this.movingAveragePeriod
            } else {
                return symbol + "_" + this.key
            }
        };
        OverlayDefinition.prototype.matchesOpts = function(a) {
            var k, match, ref;
            match = true;
            for (k in a) {
                if (k === 'symbol') {
                    if (((ref = this.symbol) != null ? ref : this.chart.current.symbol) !== a.symbol) {
                        match = false;
                        break
                    }
                } else if (k === 'moving_average_days') {
                    if (parseInt(this.opts[k], 10) !== parseInt(a[k], 10)) {
                        match = false;
                        break
                    }
                } else if (this.opts[k] !== a[k]) {
                    match = false;
                    break
                }
            }
            return match
        };
        return OverlayDefinition
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.Scale = (function() {
        Scale.X_AXIS = 1;
        Scale.Y_AXIS = 2;
        Scale.LINEAR_SCALE = 1;
        Scale.TIME_SCALE = 2;
        Scale.chart = null;
        Scale.scalar = null;
        Scale.axis = null;
        Scale.domain = [-2e308, 2e308];
        Scale.range = [-2e308, 2e308];
        Scale.orientation = null;
        Scale.tickCount = null;
        Scale.tickValues = null;
        Scale.innerTickSize = null;
        Scale.scalarType = null;
        Scale.node = null;
        Scale.layer = null;

        function Scale(b) {
            var c, ref1, ref2;
            if (b == null) {
                b = {}
            }
            this.update(b);
            this.axis = (function() {
                if ((c = b.axis) != null) {
                    return c
                } else {
                    throw "Axis must be defined.";
                }
            })();
            this.chart = (function() {
                if ((ref1 = b.chart) != null) {
                    return ref1
                } else {
                    throw "Chart instance must be defined.";
                }
            })();
            this.orientation = (ref2 = b.orientation) != null ? ref2 : (this.axis === PriceChart.Scale.X_AXIS ? 'bottom' : 'right');
            this.chart.events.on("destroy." + (this.serialize()), this.remove.bind(this));
            this.chart.events.on("resize." + (this.serialize()), (function(a) {
                return function() {
                    return d3.select(a.node).attr("transform", a.nodeTransform())
                }
            })(this))
        }
        Scale.prototype.update = function(a) {
            if (a == null) {
                a = {}
            }
            if (a.domain !== void 0) {
                this.domain = a.domain
            }
            if (a.range !== void 0) {
                this.range = a.range
            }
            if (a.tickCount !== void 0) {
                this.tickCount = a.tickCount
            }
            if (a.tickValues !== void 0) {
                this.tickValues = a.tickValues
            }
            if (a.innerTickSize !== void 0) {
                this.innerTickSize = a.innerTickSize
            }
            if (a.type !== void 0) {
                return this.scalarType = a.type
            }
        };
        Scale.prototype.generateScale = function() {
            if (this.scalarType === PriceChart.Scale.LINEAR_SCALE) {
                this.scalar = d3.scale.linear()
            } else if (this.scalarType === PriceChart.Scale.TIME_SCALE) {
                this.scalar = d3.time.scale()
            }
            return this.scalar = this.scalar.domain(this.domain).range(this.range)
        };
        Scale.prototype.axisGenerator = function() {
            var a, intervalGenerator;
            a = d3.svg.axis().scale(this.scalar);
            if (this.tickCount != null) {
                if (this.tickCount != null) {
                    a = a.ticks(this.tickCount)
                }
            } else if (intervalGenerator = this.shouldAlignToMonths()) {
                a = a.ticks(intervalGenerator)
            }
            if (this.tickValues != null) {
                a = a.tickValues(this.tickValues)
            }
            if (this.innerTickSize != null) {
                a = a.innerTickSize(this.innerTickSize)
            }
            a = a.orient(this.orientation);
            if (this.scalarType === PriceChart.Scale.TIME_SCALE) {
                a = a.tickFormat(d3.time.format.multi([
                    [".%L", function(d) {
                        return d.getMilliseconds()
                    }],
                    [":%S", function(d) {
                        return d.getSeconds()
                    }],
                    ["%I:%M", function(d) {
                        return d.getMinutes()
                    }],
                    ["%I %p", function(d) {
                        return d.getHours()
                    }],
                    ["%d", function(d) {
                        return d.getDate() !== 1
                    }],
                    ["%b", function(d) {
                        return d.getMonth()
                    }],
                    ["%Y", function(d) {
                        return true
                    }]
                ]))
            }
            return a
        };
        Scale.prototype.shouldAlignToMonths = function() {
            var e, dateRange, lowerThreshold, upperThreshold;
            if (this.scalarType === PriceChart.Scale.TIME_SCALE) {
                upperThreshold = 15552000000;
                lowerThreshold = 3024000000;
                dateRange = this.domain[1].getTime() - this.domain[0].getTime();
                e = this.range[1] - this.range[0];
                if ((lowerThreshold < dateRange && dateRange < upperThreshold)) {
                    return function(b, c) {
                        return d3.time.days(b, c).filter(function(d) {
                            var a;
                            if (d.getDate() === 1) {
                                return true
                            }
                            if (d.getDate() === 15 && (300 <= e && e < 600)) {
                                return true
                            }
                            if (((a = d.getDate()) === 1 || a === 8 || a === 15 || a === 22) && e >= 600) {
                                return true
                            }
                            return false
                        })
                    }
                } else {
                    false
                }
            }
            return false
        };
        Scale.prototype.draw = function() {
            var a;
            this.generateScale();
            if (this.node) {
                a = d3.select(this.node);
                a.transition().duration(this.chart.opts.transition_duration).call(this.axisGenerator());
                a.selectAll("path, line").attr("fill", "none").attr("shape-rendering", "crispEdges");
                if (this.layer > 0) {
                    return a.selectAll("path.domain").attr("stroke-width", "1px").attr("stroke", "black").classed("additional-axis", true)
                }
            } else {
                a = d3.select(this.chart.node).select("g.wrapper").insert("g", ".primary-chart").attr("class", this.nodeClassName()).attr("transform", this.nodeTransform());
                a.call(this.axisGenerator()).selectAll("path, line").attr("fill", "none").attr("shape-rendering", "crispEdges");
                if (this.layer > 0) {
                    a.selectAll("path.domain").attr("stroke-width", "1px").attr("stroke", "black").classed("additional-axis", true)
                }
                return this.node = a[0][0]
            }
        };
        Scale.prototype.remove = function() {
            if (this.node) {
                this.node.remove()
            }
            this.node = void 0;
            this.layer = void 0;
            return this.chart.events.on("." + (this.serialize()), null)
        };
        Scale.prototype.nodeClassName = function() {
            return [(this.axis === PriceChart.Scale.X_AXIS ? "x" : "y"), "axis", this.orientation].join(" ")
        };
        Scale.prototype.nodeTransform = function() {
            var a;
            this.layer = 0;
            if (this.axis === PriceChart.Scale.X_AXIS && this.orientation === "bottom") {
                return "translate(0, " + this.chart.opts.height + ")"
            } else if (this.axis === PriceChart.Scale.Y_AXIS && this.orientation === "right") {
                a = d3.select(this.chart.node).selectAll(".y.axis.right")[0].length - 1;
                this.layer = a;
                return "translate(" + (this.chart.opts.width + 6 + (40 * a)) + ", 0)"
            } else {
                return ""
            }
        };
        Scale.prototype.serialize = function() {
            var a, ref;
            if (this.layer) {
                a = this.layer
            } else {
                a = ((ref = d3.select(this.chart.node).selectAll("." + this.nodeClassName().replace(/ /g, "."))[0]) != null ? ref.length : void 0) || 0
            }
            return this.nodeClassName().replace(/ /g, "") + a
        };
        return Scale
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.TrendLine = (function() {
        TrendLine.chart = null;
        TrendLine.element = null;
        TrendLine.container = null;
        TrendLine.color = null;
        TrendLine.width = null;
        TrendLine.endpointType = null;
        TrendLine.isDragging = false;
        TrendLine.coordinates = null;
        TrendLine.lineDrag = null;

        function TrendLine(a, b) {
            var c, ref1, ref2, ref3, ref4, ref5;
            if (b == null) {
                b = {}
            }
            this.chart = a;
            this.container = (c = b.container) != null ? c : d3.select(this.chart.opts.canvas).select(".primary-chart");
            this.color = (ref1 = (ref2 = b.color) != null ? ref2 : (ref3 = this.chart.opts.draw_mode_colors) != null ? ref3[0] : void 0) != null ? ref1 : "red";
            this.width = (ref4 = b.width) != null ? ref4 : 1;
            this.endpointType = (ref5 = b.endpointType) != null ? ref5 : "circle";
            this.coordinates = {
                start: {
                    x: null,
                    y: null
                },
                end: {
                    x: null,
                    y: null
                }
            }
        }
        TrendLine.prototype.set = function(a) {
            if (a.x1) {
                this.coordinates.start.x = a.x1
            }
            if (a.y1) {
                this.coordinates.start.y = a.y1
            }
            if (a.x2) {
                this.coordinates.end.x = a.x2
            }
            if (a.y2) {
                this.coordinates.end.y = a.y2
            }
            return this.draw()
        };
        TrendLine.prototype.setColor = function(a) {
            this.color = a;
            return this.redraw()
        };
        TrendLine.prototype.setWidth = function(a) {
            this.width = a;
            return this.redraw()
        };
        TrendLine.prototype.setEndpointType = function(a) {
            this.endpointType = a;
            return this.redraw()
        };
        TrendLine.prototype.draw = function() {
            var b;
            if (!this.element) {
                this.element = this.container.append("g").attr("class", "trend-line-group");
                b = this.element.append("line").attr("class", "trend-line");
                this.lineDrag = d3.behavior.drag();
                b.call(this.lineDrag);
                this.lineDrag.on("dragstart", (function(a) {
                    return function() {
                        a.beginDrag();
                        return a.firstDrag = true
                    }
                })(this));
                this.lineDrag.on("drag", (function(a) {
                    return function() {
                        if (!a.firstDrag) {
                            a.coordinates.start.x += d3.event.dx;
                            a.coordinates.end.x += d3.event.dx;
                            a.coordinates.start.y += d3.event.dy;
                            a.coordinates.end.y += d3.event.dy
                        }
                        a.firstDrag = void 0;
                        return a.draw()
                    }
                })(this));
                this.lineDrag.on("dragend", (function(a) {
                    return function() {
                        a.endDrag();
                        return a.draw()
                    }
                })(this));
                b.on("contextmenu", d3.contextMenu(this.generateContextMenuDefinition()))
            } else {
                b = this.element.select("line.trend-line")
            }
            return b.attr("x1", this.coordinates.start.x).attr("x2", this.coordinates.end.x).attr("y1", this.coordinates.start.y).attr("y2", this.coordinates.end.y).attr("stroke", this.color).attr("stroke-width", this.width).attr("style", this.isDragging ? null : "cursor:move")
        };
        TrendLine.prototype.redraw = function() {
            this.beginDrag();
            this.endDrag();
            return this.draw()
        };
        TrendLine.prototype.beginDrag = function() {
            this.isDragging = true;
            if (this.element) {
                return this.element.selectAll(".endpoint").remove()
            }
        };
        TrendLine.prototype.endDrag = function() {
            this.isDragging = false;
            this.drawEndNode(this.coordinates.start);
            return this.drawEndNode(this.coordinates.end)
        };
        TrendLine.prototype.drawEndNode = function(b) {
            var c, g;
            c = d3.behavior.drag();
            g = this.element.append("g").attr("class", "endpoint").attr("style", "cursor:move");
            g.append("circle").attr("class", "endpoint-outer").attr("cx", b.x).attr("cy", b.y).attr("r", this.width * 2 + 10).attr("stroke", "transparent").attr("stroke-width", "5px").attr("fill", "transparent");
            g.append("circle").attr("class", "endpoint-inner").attr("cx", b.x).attr("cy", b.y).attr("r", this.width * 2).attr("stroke", this.color).attr("stroke-width", this.width).attr("fill", this.endpointType === "circle" ? this.getTransparencyColor() : this.color).on("mouseover", function() {
                return d3.select(this.parentNode).select(".endpoint-outer").attr("stroke", "yellow")
            }).on("mouseout", function() {
                return d3.select(this.parentNode).select(".endpoint-outer").attr("stroke", "transparent")
            }).call(c);
            g.selectAll("circle").on("contextmenu", d3.contextMenu(this.generateContextMenuDefinition()));
            c.on("dragstart", (function(a) {
                return function() {
                    if (d3.event.sourceEvent.button === 0) {
                        a.beginDrag();
                        return a.firstDrag = true
                    }
                }
            })(this));
            c.on("drag", (function(a) {
                return function() {
                    if (d3.event.sourceEvent.button === 0) {
                        if (!a.firstDrag) {
                            b.x += d3.event.dx;
                            b.y += d3.event.dy
                        }
                    }
                    a.firstDrag = void 0;
                    return a.draw()
                }
            })(this));
            return c.on("dragend", (function(a) {
                return function() {
                    if (d3.event.sourceEvent.button === 0) {
                        a.endDrag();
                        return a.draw()
                    }
                }
            })(this))
        };
        TrendLine.prototype.getTransparencyColor = function() {
            return d3.select(this.chart.opts.canvas).select("rect.border").attr("fill")
        };
        TrendLine.prototype.generateContextMenuDefinition = function() {
            var c, ref;
            c = (ref = this.chart.opts.draw_mode_colors) != null ? ref : ['red', 'orange', 'goldenrod', 'green', 'blue', 'purple'];
            return [{
                html: "Line Color:<br>" + c.reduce((function(a, b) {
                    return a + "<button class='color-picker' data-color='" + b + "' style='background-color:" + b + "'></button>"
                }), ""),
                action: (function(b) {
                    return function(e, d, i) {
                        var a;
                        a = d3.select(d3.event.target).attr("data-color");
                        return b.setColor(a)
                    }
                })(this)
            }, {
                html: "Line Width:<br> <button class='width-picker' data-width='1'>1</button> <button class='width-picker' data-width='2'>2</button> <button class='width-picker' data-width='3'>3</button> <button class='width-picker' data-width='4'>4</button> <button class='width-picker' data-width='5'>5</button>",
                action: (function(b) {
                    return function(e, d, i) {
                        var a;
                        a = d3.select(d3.event.target).attr("data-width");
                        return b.setWidth(a)
                    }
                })(this)
            }, {
                html: "Endpoint Style:<br>" + "<button class='endpoint-style-picker' data-endpoint='circle'>&#9675;</button>" + "<button class='endpoint-style-picker' data-endpoint='solid'>&#9679;</button>",
                action: (function(b) {
                    return function(e, d, i) {
                        var a;
                        a = d3.select(d3.event.target).attr("data-endpoint");
                        return b.setEndpointType(a)
                    }
                })(this)
            }, {
                label: "Delete Line",
                action: (function(a) {
                    return function(e, d, i) {
                        return a.destroy()
                    }
                })(this)
            }]
        };
        TrendLine.prototype.destroy = function() {
            return this.element.remove()
        };
        return TrendLine
    })();
    if (window.PriceChart == null) {
        window.PriceChart = {}
    }
    PriceChart.ZoomMode = (function() {
        ZoomMode.chart = null;
        ZoomMode.zoomControls = null;

        function ZoomMode(a) {
            this.chart = a;
            this.zoomControls = this.buildZoomControls();
            this.scrollControls = this.buildScrollControls()
        }
        ZoomMode.prototype.buildZoomControls = function() {
            var a, minusButton, plusButton, positionX, positionY, wrapper;
            positionX = (this.chart.opts.width / 2) + this.chart.opts.margins.left;
            positionY = this.chart.opts.height + this.chart.opts.margins.top;
            wrapper = d3.select(this.chart.opts.canvas).select("svg").append("g").attr("class", "zoom-controls").attr("transform", "translate(" + positionX + "," + positionY + ")");
            a = wrapper.append("rect").attr("x", -50).attr("y", -50).attr("height", 40).attr("width", 100).attr("fill", "transparent");
            plusButton = wrapper.append("g");
            plusButton.append("circle").attr("cx", -30).attr("cy", -30).attr("r", 15).attr("style", "cursor: pointer");
            plusButton.append("line").attr("x1", -20).attr("x2", -40).attr("y1", -30).attr("y2", -30).attr("style", "cursor: pointer");
            plusButton.append("line").attr("x1", -30).attr("x2", -30).attr("y1", -20).attr("y2", -40).attr("style", "cursor: pointer");
            minusButton = wrapper.append("g");
            minusButton.append("circle").attr("cx", 30).attr("cy", -30).attr("r", 15).attr("style", "cursor: pointer");
            minusButton.append("line").attr("x1", 20).attr("x2", 40).attr("y1", -30).attr("y2", -30).attr("style", "cursor: pointer");
            plusButton.on("mouseover", function() {
                plusButton.selectAll("*").attr("fill", "transparent").attr("stroke", "black").attr("stroke-width", 5);
                return a.attr("fill", "rgba(255,255,255,0.7)")
            }).on("mouseout", function() {
                plusButton.selectAll("*").attr("fill", "transparent").attr("stroke", "rgba(0,0,0,0.3)").attr("stroke-width", 5);
                return a.attr("fill", "transparent")
            }).on("click", this.zoomIn.bind(this));
            minusButton.on("mouseover", function() {
                minusButton.selectAll("*").attr("fill", "transparent").attr("stroke", "black").attr("stroke-width", 5);
                return a.attr("fill", "rgba(255,255,255,0.7)")
            }).on("mouseout", function() {
                minusButton.selectAll("*").attr("fill", "transparent").attr("stroke", "rgba(0,0,0,0.3)").attr("stroke-width", 5);
                return a.attr("fill", "transparent")
            }).on("click", this.zoomOut.bind(this));
            plusButton.on("mouseout")();
            minusButton.on("mouseout")();
            return wrapper
        };
        ZoomMode.prototype.buildScrollControls = function() {
            var a, positionX, positionY, rightButton, w, wrapper;
            positionX = this.chart.opts.margins.left;
            positionY = (this.chart.opts.height / 2) + this.chart.opts.margins.top - 30;
            wrapper = d3.select(this.chart.opts.canvas).select("svg").append("g").attr("class", "scroll-controls").attr("transform", "translate(" + positionX + "," + positionY + ")");
            wrapper.append("rect").attr("x", 0).attr("y", -5).attr("height", 40).attr("width", 30).attr("fill", "transparent");
            wrapper.append("rect").attr("x", this.chart.opts.width - 30).attr("y", -5).attr("height", 40).attr("width", 30).attr("fill", "transparent");
            a = wrapper.append("path").attr("d", "M20 0 L5 15 L20 30").attr("fill", "transparent").attr("stroke-width", 5).attr("style", "cursor:pointer");
            w = this.chart.opts.width;
            rightButton = wrapper.append("path").attr("d", "M" + (w - 20) + " 0 L" + (w - 5) + " 15 L" + (w - 20) + " 30").attr("fill", "transparent").attr("stroke-width", 5).attr("style", "cursor:pointer");
            a.on("mouseover", function() {
                a.attr("stroke", "black");
                return wrapper.selectAll("rect").attr("fill", "rgba(255,255,255,0.7)")
            }).on("mouseout", function() {
                a.attr("stroke", "rgba(0,0,0,0.3)");
                return wrapper.selectAll("rect").attr("fill", "transparent")
            }).on("click", this.scrollLeft.bind(this));
            rightButton.on("mouseover", function() {
                rightButton.attr("stroke", "black");
                return wrapper.selectAll("rect").attr("fill", "rgba(255,255,255,0.7)")
            }).on("mouseout", function() {
                rightButton.attr("stroke", "rgba(0,0,0,0.3)");
                return wrapper.selectAll("rect").attr("fill", "transparent")
            }).on("click", this.scrollRight.bind(this));
            a.on("mouseout")();
            rightButton.on("mouseout")();
            return wrapper
        };
        ZoomMode.prototype.zoomIn = function() {
            var a, endDate, newEndDate, newStartDate, startDate;
            startDate = this.chart.scales.bottom.domain[0].getTime();
            endDate = this.chart.scales.bottom.domain[1].getTime();
            a = Math.max(1000000000, endDate - startDate);
            if (a * 0.2 < endDate - startDate) {
                newStartDate = new Date();
                newEndDate = new Date();
                newStartDate.setTime(startDate + ((a * 0.2) / 2));
                newEndDate.setTime(endDate - ((a * 0.2) / 2));
                this.chart.set("from_date", newStartDate);
                return this.chart.set("to_date", newEndDate, true)
            }
        };
        ZoomMode.prototype.zoomOut = function() {            
            var a, endDate, newEndDate, newStartDate, startDate;
            startDate = this.chart.scales.bottom.domain[0].getTime();
            endDate = this.chart.scales.bottom.domain[1].getTime();
            a = Math.max(1000000000, endDate - startDate);
            newStartDate = new Date();
            newEndDate = new Date();
            newStartDate.setTime(startDate - ((a * 0.2) / 2));
            newEndDate.setTime(endDate + ((a * 0.2) / 2));
            if (newEndDate.getTime() > (new Date()).getTime()) {
                a = newEndDate.getTime() - (new Date()).getTime();
                newEndDate.setTime(newEndDate.getTime() - a);
                newStartDate.setTime(newStartDate.getTime() - a)
            }
            if ((this.chart.opts.maximum_date_range * 86400000) < (newEndDate.getTime() - newStartDate.getTime())) {
                newStartDate.setTime(newEndDate.getTime() - this.chart.opts.maximum_date_range * 86400000)
            }
            this.chart.set("from_date", newStartDate);
            return this.chart.set("to_date", newEndDate, true)
        };
        ZoomMode.prototype.scrollLeft = function() {
            var a, endDate, newEndDate, newStartDate, startDate;
            startDate = this.chart.scales.bottom.domain[0].getTime();
            endDate = this.chart.scales.bottom.domain[1].getTime();
            a = endDate - startDate;
            newStartDate = new Date();
            newEndDate = new Date();
            newStartDate.setTime(startDate - (a * 0.1));
            newEndDate.setTime(endDate - (a * 0.1));
            this.chart.set("from_date", newStartDate);
            return this.chart.set("to_date", newEndDate, true)
        };
        ZoomMode.prototype.scrollRight = function() {
            var a, endDate, newEndDate, newStartDate, now, startDate;
            startDate = this.chart.scales.bottom.domain[0].getTime();
            endDate = this.chart.scales.bottom.domain[1].getTime();
            a = endDate - startDate;
            newStartDate = new Date();
            newEndDate = new Date();
            newStartDate.setTime(startDate + (a * 0.1));
            newEndDate.setTime(endDate + (a * 0.1));
            if (newEndDate.getTime() > (new Date()).getTime()) {
                now = new Date();
                newEndDate.setTime(now.getTime());
                newStartDate.setTime(now.getTime() - a)
            }
            this.chart.set("from_date", newStartDate);
            return this.chart.set("to_date", newEndDate, true)
        };
        ZoomMode.prototype.destroy = function() {
            this.zoomControls.remove();
            return this.scrollControls.remove()
        };
        return ZoomMode
    })()
}).call(this);